var latl,lath, lonl,lonh, lat1,lat2, lon1,lon2;
var ms, lxs,lxn, lyw,lye, md;
var nc, llx,lly, msz, gxs,gxn, gyw,gye, gms, hms;
var kon=0, krng=0;
var canvas, ct;
/***************************************************************************/
/*  kon = 0 : no range selected yet                                        */
/*      = 1 : selecting, dragging a corner                                 */
/*      = 2 : selecting, dragging horizontal side (parallel)               */
/*      = 3 : selecting, dragging vertical side (meridian)                 */
/*      = 4 : range already selected                                       */
/***************************************************************************/
function init() {
  canvas = document.getElementById("map");
  ct = canvas.getContext("2d");
  canvas.addEventListener('mousedown', onMouseDown, false);
  canvas.addEventListener('mousemove', onMouseMove, false);
  canvas.addEventListener('mouseup', onMouseUp, false);
  nc  = parseInt(document.btsetgp.Ncc.value);
  llx = parseInt(document.btsetgp.Sllx.value);
  lly = parseInt(document.btsetgp.Slly.value);
  msz = parseInt(document.btsetgp.Smsz.value);
  gxs = parseInt(document.btsetgp.GPxs.value);
  gxn = parseInt(document.btsetgp.GPxn.value);
  gyw = parseInt(document.btsetgp.GPyw.value);
  gye = parseInt(document.btsetgp.GPye.value);
  gms = parseInt(document.btsetgp.GPms.value);
  if (gms < 0) { krng = 1; } else { krng = 0; }
  if (gms<10) {
    ms = msz
  } else if (gms<100) {
    if (gms<25){
      if (gms<20) { ms = 10; } else { ms = 20; }
    } else {
      if (gms<50) { ms = 25; } else { ms = 50; }
    }
  } else if (gms<1000) {
    if (gms<250){
      if (gms<200) { ms = 100; } else { ms = 200; }
    } else {
      if (gms<500) { ms = 250; } else { ms = 500; }
    }
  } else {
    if (gms<2500){
      if (gms<2000) { ms = 1000; } else { ms = 2000; }
    } else {
      if (gms<5000) { ms = 2500; } else { ms = 5000; }
    }
  }
  hms = msz / 2;
  lat1 = Math.floor((gxs-llx+hms)/msz);
  lat2 = Math.floor((gxn-llx+hms)/msz);
  lon1 = Math.floor((gyw-lly+hms)/msz);
  lon2 = Math.floor((gye-lly+hms)/msz);
  kon = 0; showllr(kon);
}
function showllr(key) {
  ct.clearRect(0, 0, 651, 441);
  if (kon > 0) {
    if ((lat1==lat2) || (lon1==lon2)) {
      ct.beginPath(); ct.moveTo(lon1+20, 420-lat2);
      ct.lineTo(lon2+20, 420-lat1); ct.stroke();
    } else {
      ct.strokeRect(lon1+20, 420-lat2, lon2-lon1, lat2-lat1);
    }
  }
  ct.font = "10pt Arial"; ct.textAlign = "right";
  if (key == 0) {
    lxs = 0; lxn = 0; lyw = 0; lye = 0;
  } else {
    if (lat2 < lat1) { latl = lat2; lath = lat1; }
    else { latl = lat1; lath = lat2; }
    if (lon2 < lon1) { lonl = lon2; lonh = lon1; }
    else { lonl = lon1; lonh = lon2; }
    lxs = latl*msz + llx; lxn = lath*msz + llx;
    lyw = lonl*msz + lly; lye = lonh*msz + lly;
    ct.fillText(fkm(lxn), 564, 262);
    ct.fillText(fkm(lyw), 499, 322);
    ct.fillText(fkm(lye), 629, 322);
    ct.fillText(fkm(lxs), 564, 402);
  }
  ct.fillText(String(ms), 545, 106);
  ct.fillText(String(msz), 545, 150);
  ct.fillText(String(nc), 630, 214);
  kon = key;
}
function onMouseDown(e) {
  mpx = e.clientX - canvas.offsetLeft; lon = mpx-20;
  mpy = e.clientY - canvas.offsetTop;  lat = 420-mpy;
  if (mpx < 441) {
    if ((mpx>17) && (mpx<423) && (mpy>17) && (mpy<423)) {
      lat2 = lat; lon2 = lon;
      if (lat2<0) lat2 = 0; else if (lat2>400) lat2 = 400;
      if (lon2<0) lon2 = 0; else if (lon2>400) lon2 = 400;
      if (kon == 0) { lat1 = lat2; lon1 = lon2; showllr(1); }
      else if (kon == 4) {
        if (lon2<(lonl-2) || lon2>(lonh+2) || lat2<(latl-2) || lat2>(lath+2)) {
          lat1 = lat2; lon1 = lon2; showllr(1);
        } else {
          if (lat2>(latl-3) && lat2<(latl+3) && lat2<((latl+lath+1)/2)) {
            if (lon2>(lonl-3) && lon2<(lonl+3) && lon2<((lonl+lonh+1)/2)) {
              lat1 = lath; lon1 = lonh; showllr(1);
            } else if (lon2>(lonh-3) && lon2<(lonh+3)) {
              lat1 = lath; lon1 = lonl; showllr(1);
            } else {
              lat1 = lath; lon1 = lonl; lon2 = lonh; showllr(2);
            }
          } else if (lat2>(lath-3) && lat2<(lath+3)) {
            if (lon2>(lonl-3) && lon2<(lonl+3) && lon2<((lonl+lonh+1)/2)) {
              lat1 = latl; lon1 = lonh; showllr(1);
            } else if (lon2>(lonh-3) && lon2<(lonh+3)) {
              lat1 = latl; lon1 = lonl; showllr(1);
            } else {
              lat1 = latl; lon1 = lonl; lon2 = lonh; showllr(2);
            }
          } else {
            if (lon2>(lonl-3) && lon2<(lonl+3) && lon2<((lonl+lonh+1)/2)) {
              lat1 = latl; lat2 = lath; lon1 = lonh; showllr(3);
            } else if (lon2>(lonh-3) && lon2<(lonh+3)) {
              lat1 = latl; lat2 = lath; lon1 = lonl; showllr(3);
            } else {
              lat1 = lat2; lon1 = lon2; showllr(1);
            }
          }
        }
      }
    }
  } else {
    if (kon == 4) {
      lat1 = latl; lat2 = lath; lon1 = lonl; lon2 = lonh;
      if ((mpx>569) && (mpx<580) && (mpy>400) && (mpy<411)) {
        if (lat1 > 0) { lat1--; showllr(4); }
      } else if ((mpx>569) && (mpx<580) && (mpy>379) && (mpy<390)) {
        if (lat1 < lat2) { lat1++; showllr(4); }
      } else if ((mpx>569) && (mpx<580) && (mpy>260) && (mpy<271)) {
        if (lat2 > lat1) { lat2--; showllr(4); }
      } else if ((mpx>569) && (mpx<580) && (mpy>239) && (mpy<250)) {
        if (lat2 < 400) { lat2++; showllr(4); }
      } else if ((mpx>439) && (mpx<450) && (mpy>329) && (mpy<340)) {
        if (lon1 > 0) { lon1--; showllr(4); }
      } else if ((mpx>460) && (mpx<471) && (mpy>329) && (mpy<340)) {
        if (lon1 < lon2) { lon1++; showllr(4); }
      } else if ((mpx>599) && (mpx<610) && (mpy>329) && (mpy<340)) {
        if (lon2 > lon1) { lon2--; showllr(4); }
      } else if ((mpx>620) && (mpx<631) && (mpy>329) && (mpy<340)) {
        if (lon2 < 400) { lon2++; showllr(4); }
      }
    }
    if (krng == 0) {
      if ((mpx>549) && (mpx<560) && (mpy>79) && (mpy<90)) {
        if (ms < 5000) {
          if (ms==20 || ms==200 || ms==2000) { ms += ms/4; }
          else { ms *= 2; }
          showllr(kon);
        }
      } else if ((mpx>549) && (mpx<560) && (mpy>109) && (mpy<120)) {
        if (ms > 10) {
          if (ms==25 || ms==250 || ms==2500) { ms -= ms/5; }
          else { ms /= 2; }
          showllr(kon);
        }
      }
    }
    if ((mpx>440) && (mpx<499) && (mpy>200) && (mpy<223))
      { kon=0; showllr(0); }
    if ((mpx>550) && (mpx<629) && (mpy>20) && (mpy<49))
      { showllr(kon); }
  }
}
function onMouseUp(e) {
  if ((kon>0) && (kon<4)) { showllr(4); }
}
function onMouseMove(e) {
  if ((kon>0) && (kon<4)) {
    mpx = e.clientX - canvas.offsetLeft; lon = mpx-20;
    mpy = e.clientY - canvas.offsetTop;  lat = 420-mpy;
    if (lat<0) lat = 0; else if (lat>400) lat = 400;
    if (lon<0) lon = 0; else if (lon>400) lon = 400;
    if (kon != 3) lat2 = lat;
    if (kon != 2) lon2 = lon;
    showllr(kon);
  }
}
function fkm(lm) { return(String(parseInt(lm)/1000.)); }
function getMS() { return(ms); }
function getXS() {
  var md = lxs%ms; return(fkm((md<0)? (lxs-ms-md): (lxs-md)));
}
function getYS() {
  var md = lyw%ms; return(fkm((md<0)? (lyw-ms-md): (lyw-md)));
}
function getXR() {
  var md = lxs%ms; var lx = ((md<0)? (lxs-ms-md): (lxs-md));
  lx = lxn - lx; md = lx%ms; return(fkm(lx + ((md==0)? 0: (ms-md))));
}
function getYR() {
  var md = lyw%ms; var ly = ((md<0)? (lyw-ms-md): (lyw-md));
  ly = lye - ly; md = ly%ms; return(fkm(ly + ((md==0)? 0: (ms-md))));
}
function getNX() {
  var md = lxs%ms; var lx = lxn - ((md<0)? (lxs-ms-md): (lxs-md));
  md = lx%ms; return((lx-md)/ms + ((md==0)? 1: 2));
}
function getNY() {
  var md = lyw%ms; var ly = lye - ((md<0)? (lyw-ms-md): (lyw-md));
  md = ly%ms; return((ly-md)/ms + ((md==0)? 1: 2));
}
